import sys
import os
from json import load as jsonDec

# File config
executeBashCommand = './record.sh'
bashFilename = 'record'

# Streams owners file
streamPublishersFile = 'streamPublishers.json'

#  Child
def startStream(publisher_name, stream_url, record_time, samplesNumber):
	os.execl(executeBashCommand, bashFilename, publisher_name, stream_url, record_time, samplesNumber)
	os._exit(0)

# Parent
def streamsInitializer(record_time):

	with open(streamPublishersFile) as data:
		publishers_data = jsonDec(data)

	for i in range(len(publishers_data)):
		new_pid = os.fork()
		if(new_pid == 0):
			startStream(
				publishers_data[i]["pubDirName"], 
				publishers_data[i]["streamURL"], 
				record_time, 
				publishers_data[i]["samplesNumber"]
			)
		else:
			pids = (os.getpid(), new_pid)
			print("parent: %d, child: %d\n" % pids)

def main():

	if(len(sys.argv) < 2):
		print("Record time required - eg. python startRecorders.py 60")
	else:
		record_time = sys.argv[1]
		streamsInitializer(record_time)

if __name__ == '__main__':
	main()